diff --git a/src/include/access/undoaction.h b/src/include/access/undoaction.h
new file mode 100644
index 0000000..5455259
--- /dev/null
+++ b/src/include/access/undoaction.h
@@ -0,0 +1,28 @@
+/*-------------------------------------------------------------------------
+ *
+ * undoaction.h
+ *	  undo action prototypes
+ *
+ * Portions Copyright (c) 1996-2018, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * src/include/access/undoaction.h
+ *
+ *-------------------------------------------------------------------------
+ */
+#ifndef UNDOACTION_H
+#define UNDOACTION_H
+
+#include "postgres.h"
+
+#include "access/undolog.h"
+#include "access/undorecord.h"
+
+/* undo record information */
+typedef struct UndoRecInfo
+{
+	UndoRecPtr	urp;	/* undo recptr (undo record location). */
+	UnpackedUndoRecord	*uur;	/* actual undo record. */
+} UndoRecInfo;
+
+#endif
diff --git a/src/include/access/undoaction_xlog.h b/src/include/access/undoaction_xlog.h
new file mode 100644
index 0000000..bfc6418
--- /dev/null
+++ b/src/include/access/undoaction_xlog.h
@@ -0,0 +1,74 @@
+/*-------------------------------------------------------------------------
+ *
+ * undoaction_xlog.h
+ *	  undo action XLOG definitions
+ *
+ * Portions Copyright (c) 1996-2017, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * src/include/access/undoaction_xlog.h
+ *
+ *-------------------------------------------------------------------------
+ */
+#ifndef UNDOACTION_XLOG_H
+#define UNDOACTION_XLOG_H
+
+#include "access/undolog.h"
+#include "access/xlogreader.h"
+#include "lib/stringinfo.h"
+#include "storage/off.h"
+
+/*
+ * WAL record definitions for undoactions.c's WAL operations
+ */
+#define XLOG_UNDO_PAGE				0x00
+#define XLOG_UNDO_RESET_SLOT		0x10
+#define XLOG_UNDO_APPLY_PROGRESS	0x20
+
+/*
+ * xl_undoaction_page flag values, 8 bits are available.
+ */
+#define XLU_PAGE_CONTAINS_TPD_SLOT			(1<<0)
+#define XLU_PAGE_CLEAR_VISIBILITY_MAP		(1<<1)
+#define XLU_CONTAINS_TPD_OFFSET_MAP			(1<<2)
+#define XLU_INIT_PAGE						(1<<3)
+
+/* This is what we need to know about delete */
+typedef struct xl_undoaction_page
+{
+	UndoRecPtr	urec_ptr;
+	TransactionId	xid;
+	int			trans_slot_id;	/* transaction slot id */
+} xl_undoaction_page;
+
+#define SizeOfUndoActionPage	(offsetof(xl_undoaction_page, trans_slot_id) + sizeof(int))
+
+/* This is what we need to know about undo apply progress */
+typedef struct xl_undoapply_progress
+{
+	UndoRecPtr	urec_ptr;
+	uint32		progress;
+} xl_undoapply_progress;
+
+#define SizeOfUndoActionProgress	(offsetof(xl_undoapply_progress, progress) + sizeof(uint32))
+
+/*
+ * xl_undoaction_reset_slot flag values, 8 bits are available.
+ */
+#define XLU_RESET_CONTAINS_TPD_SLOT			(1<<0)
+
+/* This is what we need to know about delete */
+typedef struct xl_undoaction_reset_slot
+{
+	UndoRecPtr	urec_ptr;
+	int			trans_slot_id;	/* transaction slot id */
+	uint8		flags;
+} xl_undoaction_reset_slot;
+
+#define SizeOfUndoActionResetSlot	(offsetof(xl_undoaction_reset_slot, flags) + sizeof(uint8))
+
+extern void undoaction_redo(XLogReaderState *record);
+extern void undoaction_desc(StringInfo buf, XLogReaderState *record);
+extern const char *undoaction_identify(uint8 info);
+
+#endif   /* UNDOACTION_XLOG_H */
diff --git a/src/include/access/undodiscard.h b/src/include/access/undodiscard.h
new file mode 100644
index 0000000..70d6408
--- /dev/null
+++ b/src/include/access/undodiscard.h
@@ -0,0 +1,31 @@
+/*-------------------------------------------------------------------------
+ *
+ * undoinsert.h
+ *	  undo discard definitions
+ *
+ * Portions Copyright (c) 1996-2017, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * src/include/access/undodiscard.h
+ *
+ *-------------------------------------------------------------------------
+ */
+#ifndef UNDODISCARD_H
+#define UNDODISCARD_H
+
+#include "access/undolog.h"
+#include "access/xlogdefs.h"
+#include "catalog/pg_class.h"
+#include "storage/lwlock.h"
+
+/*
+ * Discard the undo for all the transaction whose xid is smaller than xmin
+ *
+ *	Check the DiscardInfo memory array for each slot (every undo log) , process
+ *	the undo log for all the slot which have xid smaller than xmin or invalid
+ *	xid. Fetch the record from the undo log transaction by transaction until we
+ *	find the xid which is not smaller than xmin.
+ */
+extern void UndoDiscard(TransactionId xmin, bool *hibernate);
+
+#endif   /* UNDODISCARD_H */
diff --git a/src/include/access/undoinsert.h b/src/include/access/undoinsert.h
index c333f00..5e208ad 100644
--- a/src/include/access/undoinsert.h
+++ b/src/include/access/undoinsert.h
@@ -46,5 +46,7 @@ extern void UndoSetPrepareSize(UnpackedUndoRecord *undorecords, int nrecords,
 				   TransactionId xid, UndoPersistence upersistence);
 extern UndoRecPtr UndoGetPrevUndoRecptr(UndoRecPtr urp, uint16 prevlen, UndoRecPtr prevurp);
 extern void ResetUndoBuffers(void);
+extern void PrepareUpdateUndoActionProgress(UndoRecPtr urecptr, int progress);
+extern void UndoRecordUpdateTransInfo(int idx);
 
 #endif							/* UNDOINSERT_H */
diff --git a/src/include/access/undorecord.h b/src/include/access/undorecord.h
index 0dcf1b1..79eb173 100644
--- a/src/include/access/undorecord.h
+++ b/src/include/access/undorecord.h
@@ -20,6 +20,17 @@
 #include "storage/buf.h"
 #include "storage/off.h"
 
+typedef enum undorectype
+{
+	UNDO_INSERT,
+	UNDO_MULTI_INSERT,
+	UNDO_DELETE,
+	UNDO_INPLACE_UPDATE,
+	UNDO_UPDATE,
+	UNDO_XID_LOCK_ONLY,
+	UNDO_XID_MULTI_LOCK_ONLY,
+	UNDO_ITEMID_UNUSED
+} undorectype;
 
 /*
  * Every undo record begins with an UndoRecordHeader structure, which is
@@ -30,6 +41,7 @@
  */
 typedef struct UndoRecordHeader
 {
+	RmgrId		urec_rmid;		/* RMGR [XXX:TODO: this creates an alignment hole?] */
 	uint8		urec_type;		/* record type code */
 	uint8		urec_info;		/* flag bits */
 	uint16		urec_prevlen;	/* length of previous record in bytes */
@@ -37,7 +49,7 @@ typedef struct UndoRecordHeader
 
 	/*
 	 * Transaction id that has modified the tuple present in this undo record.
-	 * If this is older than oldestXidWithEpochHavingUndo, then we can
+	 * If this is older than oldestXidHavingUndo, then we can
 	 * consider the tuple in this undo record as visible.
 	 */
 	TransactionId urec_prevxid;
@@ -161,6 +173,7 @@ typedef struct UndoRecordPayload
  */
 typedef struct UnpackedUndoRecord
 {
+	RmgrId		uur_rmid;		/* rmgr ID */
 	uint8		uur_type;		/* record type code */
 	uint8		uur_info;		/* flag bits */
 	uint16		uur_prevlen;	/* length of previous record */
diff --git a/src/include/access/xact.h b/src/include/access/xact.h
index ddaa633..f20a47c 100644
--- a/src/include/access/xact.h
+++ b/src/include/access/xact.h
@@ -419,6 +419,7 @@ extern XLogRecPtr XactLogAbortRecord(TimestampTz abort_time,
 				   int xactflags, TransactionId twophase_xid,
 				   const char *twophase_gid);
 extern void xact_redo(XLogReaderState *record);
+extern void XactPerformUndoActionsIfPending(void);
 
 /* xactdesc.c */
 extern void xact_desc(StringInfo buf, XLogReaderState *record);
diff --git a/src/include/access/xlog.h b/src/include/access/xlog.h
index d18a1cd..b630d8c 100644
--- a/src/include/access/xlog.h
+++ b/src/include/access/xlog.h
@@ -225,6 +225,9 @@ extern bool XLOG_DEBUG;
 #define XLOG_INCLUDE_ORIGIN		0x01	/* include the replication origin */
 #define XLOG_MARK_UNIMPORTANT	0x02	/* record not important for durability */
 
+/* Generate a 64-bit xid by using epoch and 32-bit xid. */
+#define MakeEpochXid(epoch, xid) \
+				((epoch << 32) | (xid))
 
 /* Checkpoint statistics */
 typedef struct CheckpointStatsData
diff --git a/src/include/access/xlog_internal.h b/src/include/access/xlog_internal.h
index 3c86037..18c64db 100644
--- a/src/include/access/xlog_internal.h
+++ b/src/include/access/xlog_internal.h
@@ -21,8 +21,10 @@
 
 #include "access/xlogdefs.h"
 #include "access/xlogreader.h"
+#include "access/undorecord.h"
 #include "datatype/timestamp.h"
 #include "lib/stringinfo.h"
+#include "nodes/pg_list.h"
 #include "pgtime.h"
 #include "storage/block.h"
 #include "storage/relfilenode.h"
@@ -294,9 +296,14 @@ typedef struct RmgrData
 	void		(*rm_startup) (void);
 	void		(*rm_cleanup) (void);
 	void		(*rm_mask) (char *pagedata, BlockNumber blkno);
+	bool		(*rm_undo) (List *luinfo, UndoRecPtr urec_ptr, Oid reloid,
+				    TransactionId xid, BlockNumber blkno,
+				    bool blk_chain_complete, bool rellock,
+				    int options);
+	void		(*rm_undo_desc) (StringInfo buf, UnpackedUndoRecord *record);
 } RmgrData;
 
-extern const RmgrData RmgrTable[];
+extern PGDLLIMPORT const RmgrData RmgrTable[];
 
 /*
  * Exported to support xlog switching from checkpointer
diff --git a/src/include/catalog/pg_control.h b/src/include/catalog/pg_control.h
index a4aa83b..8a52124 100644
--- a/src/include/catalog/pg_control.h
+++ b/src/include/catalog/pg_control.h
@@ -61,6 +61,13 @@ typedef struct CheckPoint
 	 * set to InvalidTransactionId.
 	 */
 	TransactionId oldestActiveXid;
+
+	/*
+	 * Oldest transaction id which is having undo. Include this value
+	 * in the checkpoint record so that whenever server starts we get proper
+	 * value.
+	 */
+	uint32 oldestXidHavingUndo;
 } CheckPoint;
 
 /* XLOG info values for XLOG rmgr */
diff --git a/src/include/miscadmin.h b/src/include/miscadmin.h
index c9e3500..8edbbda 100644
--- a/src/include/miscadmin.h
+++ b/src/include/miscadmin.h
@@ -245,6 +245,7 @@ extern PGDLLIMPORT bool allowSystemTableMods;
 extern PGDLLIMPORT int work_mem;
 extern PGDLLIMPORT int maintenance_work_mem;
 extern PGDLLIMPORT int max_parallel_maintenance_workers;
+extern PGDLLIMPORT int rollback_overflow_size;
 
 extern int	VacuumCostPageHit;
 extern int	VacuumCostPageMiss;
diff --git a/src/include/pgstat.h b/src/include/pgstat.h
index e6b22f4..319b36f 100644
--- a/src/include/pgstat.h
+++ b/src/include/pgstat.h
@@ -749,6 +749,7 @@ typedef enum BackendState
 #define PG_WAIT_TIMEOUT				0x09000000U
 #define PG_WAIT_IO					0x0A000000U
 #define PG_WAIT_PAGE_TRANS_SLOT		0x0B000000U
+#define PG_WAIT_ROLLBACK_HT			0x0C000000U
 
 /* ----------
  * Wait Events - Activity
@@ -774,6 +775,8 @@ typedef enum
 	WAIT_EVENT_WAL_RECEIVER_MAIN,
 	WAIT_EVENT_WAL_SENDER_MAIN,
 	WAIT_EVENT_WAL_WRITER_MAIN,
+	WAIT_EVENT_UNDO_DISCARD_WORKER_MAIN,
+	WAIT_EVENT_UNDO_LAUNCHER_MAIN
 } WaitEventActivity;
 
 /* ----------
diff --git a/src/include/postmaster/discardworker.h b/src/include/postmaster/discardworker.h
new file mode 100644
index 0000000..f00c6c4
--- /dev/null
+++ b/src/include/postmaster/discardworker.h
@@ -0,0 +1,25 @@
+/*-------------------------------------------------------------------------
+ *
+ * discardworker.h
+ *	  Exports from postmaster/discardworker.c.
+ *
+ * Portions Copyright (c) 1996-2017, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * src/include/postmaster/discardworker.h
+ *
+ *-------------------------------------------------------------------------
+ */
+#ifndef _DISCARDWORKER_H
+#define _DISCARDWORKER_H
+
+/*
+ * This function will perform multiple actions based on need. (a) retrieve
+ * transactions which have become all-visible and truncate the associated undo
+ * logs or will increment the tail pointer. (b) drop the buffers corresponding
+ * to truncated pages.
+ */
+extern void DiscardWorkerMain(Datum main_arg) pg_attribute_noreturn();
+extern void DiscardWorkerRegister(void);
+
+#endif   /* _DISCARDWORKER_H */
diff --git a/src/include/postmaster/undoloop.h b/src/include/postmaster/undoloop.h
new file mode 100644
index 0000000..21d91c3
--- /dev/null
+++ b/src/include/postmaster/undoloop.h
@@ -0,0 +1,89 @@
+/*-------------------------------------------------------------------------
+ *
+ * undoloop.h
+ *	  Exports from postmaster/undoloop.c.
+ *
+ * Portions Copyright (c) 1996-2017, PostgreSQL Global Development Group
+ *
+ * src/include/postmaster/undoloop.h
+ *
+ *-------------------------------------------------------------------------
+ */
+#ifndef _UNDOLOOP_H
+#define _UNDOLOOP_H
+
+#include "access/undoinsert.h"
+#include "utils/hsearch.h"
+#include "utils/relcache.h"
+
+
+/* Various options while executing the undo actions for the page. */
+#define UNDO_ACTION_UPDATE_TPD		0x0001
+
+/* Remembers the last seen RecentGlobalXmin */
+TransactionId latestRecentGlobalXmin;
+
+/*
+ * This function will read the undo records starting from the undo
+ * from_urecptr till to_urecptr and if to_urecptr is invalid then till the
+ * first undo location of transaction.  This also discards the buffers by
+ * calling DropUndoBuffers for which undo log is removed.  This function
+ * can be used by RollbackToSavePoint, by Rollback, by undoworker to complete
+ * the work of errored out transactions or when there is an error in single
+ * user mode.
+ */
+extern void execute_undo_actions(UndoRecPtr from_urecptr,
+			UndoRecPtr to_urecptr, bool nopartial, bool rewind, bool rellock);
+extern void process_and_execute_undo_actions_page(UndoRecPtr from_urecptr,
+							Relation rel, Buffer buffer, uint32 epoch,
+							TransactionId xid, int slot_no);
+
+/*
+ * This function will be responsible to truncate the undo logs
+ * for transactions that become all-visible after RecentGlobalXmin has
+ * advanced (value is different than latestRecentGlobalXmin).  The easiest
+ * way could be to traverse the undo log array that contains least transaction
+ * id for that undo log and see if it precedes RecentGlobalXmin, then start
+ * discarding the undo log for that transaction (moving the tail pointer of
+ * undo log) till it finds the transaction which is not all-visible.  This also
+ * discards the buffers by calling ForgetBuffer for which undo log is
+ * removed.  This function can be invoked by undoworker or after commit in
+ * single user mode.
+ */
+extern void	recover_undo_pages();
+
+/*
+ * To increase the efficiency of the zheap system, we create a hash table for
+ * the rollbacks. All the rollback requests exceeding certain threshold, are
+ * pushed to this table. Undo worker starts reading the entries from this hash
+ * table one at a time, performs undo actions related to the respective xid and
+ * removes them from the hash table. This way backend is free from performing the
+ * undo actions in case of heavy rollbacks. The data structures and the routines
+ * required for this infrastructure are as follows.
+ */
+
+/* This is the data structure for each hash table entry for rollbacks. */
+typedef struct RollbackHashEntry
+{
+	UndoRecPtr start_urec_ptr;
+	UndoRecPtr end_urec_ptr;
+	Oid		   dbid;
+} RollbackHashEntry;
+
+extern bool RollbackHTIsFull(void);
+
+/* To push the rollback requests from backend to the respective hash table */
+extern bool PushRollbackReq(UndoRecPtr start_urec_ptr, UndoRecPtr end_urec_ptr,
+							Oid dbid);
+
+/* To perform the undo actions reading from the hash table */
+extern void RollbackFromHT(Oid dbid);
+/* To calculate the size of the hash table size for rollabcks. */
+extern int RollbackHTSize(void);
+
+/* To initialize the hash table in shared memory for rollbacks. */
+extern void InitRollbackHashTable(void);
+extern List *RollbackHTGetDBList(void);
+extern bool ConditionTransactionUndoActionLock(TransactionId xid);
+extern void TransactionUndoActionLockRelease(TransactionId xid);
+#endif   /* _UNDOLOOP_H */
diff --git a/src/include/postmaster/undoworker.h b/src/include/postmaster/undoworker.h
new file mode 100644
index 0000000..c277e01
--- /dev/null
+++ b/src/include/postmaster/undoworker.h
@@ -0,0 +1,39 @@
+/*-------------------------------------------------------------------------
+ *
+ * undoworker.h
+ *	  Exports from postmaster/undoworker.c.
+ *
+ * Portions Copyright (c) 1996-2017, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * src/include/postmaster/undoworker.h
+ *
+ *-------------------------------------------------------------------------
+ */
+#ifndef _UNDOWORKER_H
+#define _UNDOWORKER_H
+
+/* GUC options */
+/* undo worker sleep time between rounds */
+extern int	UndoWorkerDelay;
+
+/*
+ * This function will perform multiple actions based on need. (a) retreive
+ * transaction and its corresponding undopoiter from shared memory queue and
+ * call undoloop to perform undo actions.  After applying all the undo records
+ * for a particular transaction, it will increment the tail pointer in undo log.
+ * (b) it needs to retrieve transactions which have become all-visible and truncate
+ * the associated undo logs or will increment the tail pointer. (c) udjust the
+ * number of undo workers based on the work required to perform undo actions
+ * (it could be size of shared memory queue containing transactions that needs
+ * aborts). (d) drop the buffers corresponding to truncated pages (e) Sleep for
+ * UndoWorkerDelay, if there is no more work.
+ */
+extern void UndoWorkerMain(Datum main_arg) pg_attribute_noreturn();
+extern void UndoLauncherRegister(void);
+extern void UndoLauncherShmemInit(void);
+extern Size UndoLauncherShmemSize(void);
+extern void UndoLauncherMain(Datum main_arg);
+extern void UndoWorkerMain(Datum main_arg);
+
+#endif   /* _UNDOWORKER_H */
diff --git a/src/include/storage/lock.h b/src/include/storage/lock.h
index 16b927c..1d3ed2e 100644
--- a/src/include/storage/lock.h
+++ b/src/include/storage/lock.h
@@ -150,6 +150,8 @@ typedef enum LockTagType
 	LOCKTAG_VIRTUALTRANSACTION, /* virtual transaction (ditto) */
 	/* ID info for a virtual transaction is its VirtualTransactionId */
 	LOCKTAG_SPECULATIVE_TOKEN,	/* speculative insertion Xid and token */
+	/* ID info for an transaction undoaction is transaction id */
+	LOCKTAG_TRANSACTION_UNDOACTION,	/* transaction (waiting for undoaction) */
 	/* ID info for a transaction is its TransactionId */
 	LOCKTAG_OBJECT,				/* non-relation database object */
 	/* ID info for an object is DB OID + CLASS OID + OBJECT OID + SUBID */
@@ -246,6 +248,14 @@ typedef struct LOCKTAG
 	 (locktag).locktag_type = LOCKTAG_SPECULATIVE_TOKEN, \
 	 (locktag).locktag_lockmethodid = DEFAULT_LOCKMETHOD)
 
+#define SET_LOCKTAG_TRANSACTION_UNDOACTION(locktag,xid) \
+	((locktag).locktag_field1 = (xid), \
+	 (locktag).locktag_field2 = 0, \
+	 (locktag).locktag_field3 = 0, \
+	 (locktag).locktag_field4 = 0, \
+	 (locktag).locktag_type = LOCKTAG_TRANSACTION_UNDOACTION, \
+	 (locktag).locktag_lockmethodid = DEFAULT_LOCKMETHOD)
+
 #define SET_LOCKTAG_OBJECT(locktag,dboid,classoid,objoid,objsubid) \
 	((locktag).locktag_field1 = (dboid), \
 	 (locktag).locktag_field2 = (classoid), \
diff --git a/src/include/storage/proc.h b/src/include/storage/proc.h
index d203acb..efde86d 100644
--- a/src/include/storage/proc.h
+++ b/src/include/storage/proc.h
@@ -270,6 +270,8 @@ typedef struct PROC_HDR
 	int			startupProcPid;
 	/* Buffer id of the buffer that Startup process waits for pin on, or -1 */
 	int			startupBufferPinWaitBufId;
+	/* Oldest transaction id which is having undo. */
+	pg_atomic_uint32 oldestXidHavingUndo;
 } PROC_HDR;
 
 extern PGDLLIMPORT PROC_HDR *ProcGlobal;
-- 
1.8.3.1

